import * as mc from "@minecraft/server";

mc.world.beforeEvents.itemUseOn.subscribe(async data => {
    const item = data.itemStack;
    const block = data.block;
    const loc = block.location;
    const player = data.source;

    if (player.isSneaking && item.typeId.endsWith('_hoe')) {
    let r = 0;
    const Cblock = new Set([
    "minecraft:pumpkin",
    "minecraft:melon_block"
    ]);
    const dirts = new Set([
    "minecraft:dirt",
    "minecraft:dirt_with_roots",
    "minecraft:grass_block",
    "minecraft:grass_path",
    "minecraft:mycelium",
    "minecraft:podzol"
    ]);

    switch (item.typeId) {
      case "minecraft:stone_hoe":
        r = 1;
        break;
      case "minecraft:iron_hoe":
        r = 2;
        break;
      case "minecraft:diamond_hoe":
        r = 3;
        break;
      case "minecraft:netherite_hoe":
        r = 4;
        break;
     }

     if (r === 0) {
        return;
     }

     const maxBlocksPerPart = 64;
     const totalBlocks = (2 * r + 1) ** 2;
     const parts = Math.ceil(totalBlocks / maxBlocksPerPart);

     for (let part = 0; part < parts; part++) {
     const start = part * maxBlocksPerPart;
     const end = Math.min(start + maxBlocksPerPart, totalBlocks);

       for (let index = start; index < end; index++) {
       const i = loc.x - r + Math.floor(index / (2 * r + 1));
       const j = loc.z - r + (index % (2 * r + 1));
       const Oblock = player.dimension.getBlock({ x: i, y: loc.y, z: j });
        if (Cblock.has(block.typeId)) {
           if (Cblock.has(Oblock.typeId)) {
                player.runCommandAsync(`setblock ${i} ${loc.y} ${j} minecraft:air destroy`);
        }} else {
        if (Oblock.typeId === "minecraft:coarse_dirt") {
           player.runCommandAsync(`setblock ${i} ${loc.y} ${j} minecraft:dirt`);
          } else if (dirts.has(Oblock.typeId)) {
              player.runCommandAsync(`setblock ${i} ${loc.y} ${j} minecraft:farmland`);
            }
        }}
    }}
});

mc.world.beforeEvents.playerBreakBlock.subscribe(async data => {
    const item = data.itemStack;
    const block = data.block;
    const loc = block.location;
    const player = data.player;

    if (item.typeId.endsWith('_hoe')) {
    const crops = new Set([
    "minecraft:beetroot",
    "minecraft:carrots",
    "minecraft:potatoes",
    "minecraft:wheat"
    ]);
    let r = 0;
    if (!player.isSneaking) {
    switch (item.typeId) {
      case "minecraft:stone_hoe":
        r = 1;
        break;
      case "minecraft:iron_hoe":
        r = 2;
        break;
      case "minecraft:diamond_hoe":
        r = 3;
        break;
      case "minecraft:netherite_hoe":
        r = 4;
        break;
     }}

     if (!crops.has(block.typeId)) {
        return;
     }

     const maxBlocksPerPart = 64;
     const totalBlocks = (2 * r + 1) ** 2;
     const parts = Math.ceil(totalBlocks / maxBlocksPerPart);

     for (let part = 0; part < parts; part++) {
     const start = part * maxBlocksPerPart;
     const end = Math.min(start + maxBlocksPerPart, totalBlocks);

       for (let index = start; index < end; index++) {
       const i = loc.x - r + Math.floor(index / (2 * r + 1));
       const j = loc.z - r + (index % (2 * r + 1));
       const Oblock = player.dimension.getBlock({ x: i, y: loc.y, z: j });
       if (crops.has(Oblock.typeId)) {
         let growth = Oblock.permutation.getState('growth');
         if (growth == 7) {
            player.runCommandAsync(`setblock ${i} ${loc.y} ${j} ${Oblock.typeId} destroy`);
            }
        }}
    }}
});